<template>
    <div>
        <v-row>
            <v-col cols="4">
                <v-card>
                    <v-list-item two-line>
                        <v-list-item-content>
                            <div class="subtitle-1 text--secondary font-weight-bold mb-3">
                                {{ $t('discount') }} {{ loadingOverall ? '' : overall.discount_code.discount | discount(overall.discount_code.discount_type) }}
                            </div>

                            <v-skeleton-loader
                                :loading="loadingOverall"
                                type="text"
                            >
                                <v-list-item-title class="headline d-flex">
                                    <ValidationObserver ref="observer" v-slot="{ validate, reset }">
                                        <ValidationProvider v-slot="{ errors }" name="ref_code" rules="required|max:10">
                                            <v-text-field
                                                ref="code"
                                                class="pa-0 referral-code"
                                                v-model="overall.referral_code"
                                                :disabled="!!!editing"
                                                :loading="updatingCode"
                                                :error-messages="errors"
                                                maxlength="10"
                                                background-color="transparent"
                                                hide-details="auto"
                                                flat
                                            >
                                            </v-text-field>
                                        </ValidationProvider>
                                    </ValidationObserver>

                                    <div>
                                        <v-btn icon @click="editReferralCode">
                                            <v-icon>{{ !!!editing ? 'edit' : 'done' }}</v-icon>
                                        </v-btn>
                                        <v-btn icon v-clipboard="() => referralCodeUrl">
                                            <v-icon>content_copy</v-icon>
                                        </v-btn>
                                    </div>
                                </v-list-item-title>
                            </v-skeleton-loader>
                        </v-list-item-content>

                        <v-list-item-avatar
                            size="60"
                            color="purple darken-1"
                        >
                            <v-icon large color="white">code</v-icon>
                        </v-list-item-avatar>
                    </v-list-item>
                </v-card>
            </v-col>

            <v-col cols="4">
                <v-card>
                    <v-list-item two-line>
                        <v-list-item-content>
                            <div class="subtitle-1 text--secondary font-weight-bold mb-4">{{ $t('commission') }}</div>
                            <v-list-item-title class="headline mb-1">
                                <v-skeleton-loader
                                    :loading="loadingOverall"
                                    type="text"
                                >
                                    {{ overall.commission | currency }} MYR
                                </v-skeleton-loader>
                            </v-list-item-title>
                        </v-list-item-content>

                        <v-list-item-avatar
                            size="60"
                            color="deep-orange darken-1"
                        >
                            <v-icon large color="white">attach_money</v-icon>
                        </v-list-item-avatar>
                    </v-list-item>
                </v-card>
            </v-col>

            <v-col cols="4">
                <v-card>
                    <v-list-item two-line>
                        <v-list-item-content>
                            <div class="subtitle-1 text--secondary font-weight-bold mb-4">{{ $t('total_earn') }}</div>
                            <v-list-item-title class="headline mb-1">
                                <v-skeleton-loader
                                    :loading="loadingOverall"
                                    type="text"
                                >
                                    {{ overall.sales | currency }} MYR
                                </v-skeleton-loader>
                            </v-list-item-title>
                        </v-list-item-content>

                        <v-list-item-avatar
                            size="60"
                            color="pink darken-1"
                        >
                            <v-icon large color="white">credit_card</v-icon>
                        </v-list-item-avatar>
                    </v-list-item>
                </v-card>
            </v-col>

            <v-col cols="4">
                <v-card>
                    <v-list-item two-line>
                        <v-list-item-content>
                            <div class="subtitle-1 text--secondary font-weight-bold mb-4">{{ $t('total_member') }}</div>
                            <v-list-item-title class="headline mb-1">
                                <v-skeleton-loader
                                    :loading="loadingOverall"
                                    type="text"
                                >
                                    {{ overall.total_member }}
                                </v-skeleton-loader>
                            </v-list-item-title>
                        </v-list-item-content>

                        <v-list-item-avatar
                            size="60"
                            color="amber darken-1"
                        >
                            <v-icon large color="white">person</v-icon>
                        </v-list-item-avatar>
                    </v-list-item>
                </v-card>
            </v-col>
        </v-row>

        <v-row>
            <v-col>
                <v-container fluid class="fill-height px-0">
                    <v-row>
                        <v-col cols="6">
                            <v-card class="sales">
                                <v-toolbar flat height="100" class="pa-1">
                                    <v-toolbar-title>{{ $t('overall_sales') }}</v-toolbar-title>

                                    <v-spacer></v-spacer>

                                    <v-col>
                                        <v-menu
                                            v-model="salesDateMenu"
                                            :close-on-content-click="false"
                                            transition="scale-transition"
                                            min-width="250px"
                                        >
                                            <template v-slot:activator="{ on, attrs }">
                                                <v-text-field
                                                    v-model="totalSalesDate"
                                                    prepend-icon="event"
                                                    :label="$t('filter_by', [$t('date')])"
                                                    readonly
                                                    hide-details
                                                    v-bind="attrs"
                                                    v-on="on"
                                                    outlined
                                                >
                                                </v-text-field>
                                            </template>
                                            <v-date-picker
                                                type="month"
                                                v-model="totalSalesDate"
                                                @input="salesDateMenu = false"
                                                @change="onTotalSalesDateChange"
                                            >
                                            </v-date-picker>
                                        </v-menu>
                                    </v-col>
                                </v-toolbar>
                                <v-progress-linear :active="loadingTotalSalesChart" indeterminate></v-progress-linear>
                                <sales-chart class="pa-5" :chart-data="sales"></sales-chart>
                            </v-card>
                        </v-col>

                        <v-col cols="6">
                            <v-card class="sales">
                                <v-toolbar flat height="100" class="pa-1">
                                    <v-toolbar-title>{{ $t('total_member_sales') }}</v-toolbar-title>

                                    <v-spacer></v-spacer>

                                    <v-col>
                                        <v-menu
                                            v-model="memberSalesDateMenu"
                                            :close-on-content-click="false"
                                            transition="scale-transition"
                                            min-width="250px"
                                        >
                                            <template v-slot:activator="{ on, attrs }">
                                                <v-text-field
                                                    v-model="totalMemberSalesDate"
                                                    prepend-icon="event"
                                                    :label="$t('filter_by', [$t('date')])"
                                                    readonly
                                                    hide-details
                                                    v-bind="attrs"
                                                    v-on="on"
                                                    outlined
                                                >
                                                </v-text-field>
                                            </template>
                                            <v-date-picker
                                                type="month"
                                                v-model="totalMemberSalesDate"
                                                @input="memberSalesDateMenu = false"
                                                @change="onTotalMemberSalesDateChange"
                                            >
                                            </v-date-picker>
                                        </v-menu>
                                    </v-col>
                                </v-toolbar>
                                <v-progress-linear :active="loadingTotalMemberSalesChart" indeterminate></v-progress-linear>
                                <sales-chart class="pa-5" :chart-data="memberSales"></sales-chart>
                            </v-card>
                        </v-col>
                    </v-row>
                </v-container>
            </v-col>
        </v-row>

        <v-row>
            <v-col>
                <v-card>
                    <v-container class="pa-5">
                        <v-row>
                            <v-col>
                                <v-card flat class="pa-0">
                                    <v-toolbar flat>
                                        <v-toolbar-title>{{ $t('sales_history') }}</v-toolbar-title>

                                        <v-spacer></v-spacer>

                                        <v-col cols="3">
                                            <v-menu
                                                v-model="dateMenu"
                                                :close-on-content-click="false"
                                                transition="scale-transition"
                                                min-width="250px"
                                            >
                                                <template v-slot:activator="{ on, attrs }">
                                                    <v-text-field
                                                        v-model="filterDate"
                                                        prepend-icon="event"
                                                        :label="$t('filter_by', [$t('date')])"
                                                        readonly
                                                        hide-details
                                                        v-bind="attrs"
                                                        v-on="on"
                                                        outlined
                                                    >
                                                    </v-text-field>
                                                </template>
                                                <v-date-picker
                                                    type="month"
                                                    v-model="filterDate"
                                                    @input="dateMenu = false"
                                                    @change="onDateChange"
                                                >
                                                </v-date-picker>
                                            </v-menu>
                                        </v-col>
                                    </v-toolbar>
                                </v-card>
                            </v-col>
                        </v-row>

                        <v-row>
                            <v-col>
                                <v-data-table
                                    :headers="headers"
                                    :items="items"
                                    :options.sync="options"
                                    :server-items-length="total"
                                    item-key="id"
                                    group-by="by.id"
                                    :loading="loadingSales"
                                    :loading-text="$t('loading')"
                                >
                                    <template v-slot:group.header="{ isOpen, toggle, headers, items }">
                                        <td :colspan="headers.length">
                                            <v-btn icon @click="toggle">
                                                <v-icon :class="isOpen ? 'mb-4' : ''">
                                                    {{ isOpen ? 'minimize' : 'add' }}
                                                </v-icon>
                                            </v-btn>
                                            {{ items[0].by ? $t('by_member', [items[0].by.level, items[0].by.name]) : $t('by_you') }}
                                        </td>
                                    </template>

                                    <template v-slot:item="{ item, expand, isExpanded }">
                                        <tr @click="expand(!isExpanded)">
                                            <td>{{ item.created_at | date }}</td>
                                            <td>{{ item.customer_name }}</td>
                                            <td class="text-right">
                                                {{ item.amount | currency }} {{ item.currency }}
                                            </td>
                                            <td class="text-right">
                                                {{ item.order_discount | discount(item.order_discount_type, item.currency, item.currency_rate) }}
                                            </td>
                                            <td class="text-right">{{ item.commission | currency }} MYR</td>
                                            <td>
                                                <v-icon>keyboard_arrow_down</v-icon>
                                            </td>
                                        </tr>
                                    </template>

                                    <template v-slot:no-data>
                                        {{ $t('no_data') }}
                                    </template>

                                    <template v-slot:no-results>
                                        {{ $t('no_result') }}
                                    </template>

                                    <template v-slot:expanded-item="{ headers, item }">
                                    </template>
                                </v-data-table>
                            </v-col>
                        </v-row>
                    </v-container>
                </v-card>
            </v-col>
        </v-row>
    </div>
</template>

<script>
    import { ValidationObserver, ValidationProvider } from 'vee-validate';
    import SalesChart from "../../../plugins/charts/sales";
    import permission from '../../../mixins/permission';
    import util from '../../../mixins/util';
    import DataTable from "../DataTable";
    import moment from 'moment';

    export default {
        name: "UserHome",
        components: {DataTable, ValidationObserver, ValidationProvider, SalesChart},
        mixins: [permission, util],
        data: () => ({
            dateMenu: false,
            salesDateMenu: false,
            memberSalesDateMenu: false,
            loadingOverall: true,
            loadingSales: false,
            overall: {
                discount_code: {
                    discount: 0,
                    discount_type: 2,
                },
                referral_code: '',
                commission: 0,
                sales: 0,
                total_member: 0
            },
            editing: null,
            updatingCode: false,
            sales: {},
            memberSales: {},
            items: [],
            total: 0,
            options: {},
            loadingTotalSalesChart: false,
            loadingTotalMemberSalesChart: false,
            totalSalesDate: moment().format('YYYY-MM'),
            totalMemberSalesDate: moment().format('YYYY-MM'),
            filterDate: moment().format('YYYY-MM')
        }),
        computed: {
            headers() {
                return [
                    { text: 'By', value: 'by.id' },
                    { text: this.$t('date'), value: 'created_at', groupable: false, },
                    { text: this.$t('customer_name'), value: 'customer_name', sortable: false, groupable: false },
                    { text: this.$t('amount'), value: 'amount', sortable: false, align: 'right', groupable: false },
                    { text: this.$t('order_discount'), value: 'order_discount', sortable: false, align: 'right', groupable: false },
                    { text: this.$t('commission'), value: 'commission', sortable: false, align: 'right', groupable: false },
                    { text: '', value: 'expand-icon', sortable: false, groupable: false },
                ]
            },

            referralCodeUrl() {
                return window.location.host + '?ref_code=' + this.overall.referralCode
            },
        },
        watch: {
            options: {
                handler() {
                    this.getDataFromApi()
                        .then(({ items, total }) => {
                            this.loadingSales = false;
                            this.items = items;
                            this.total = total;
                        })
                },
                deep: true
            },
        },
        mounted() {
            this.getOverall();
            this.getTotalSales();
            this.getTotalMemberSales();
        },
        methods: {
            onDateChange() {
                this.getDataFromApi()
                    .then(({ items, total }) => {
                        this.loadingSales = false;
                        this.items = items;
                        this.total = total;
                    })
            },

            getDataFromApi () {
                this.loadingSales = true;

                return new Promise((resolve, reject) => {
                    const {sortBy, sortDesc, page, itemsPerPage} = this.options;

                    axios.get('api/affiliate/sales', {
                        params: {
                            page: page,
                            itemsPerPage: itemsPerPage,
                            date: this.filterDate
                        }
                    })
                        .then(response => {
                            let items = response.data.data;
                            const total = response.data.meta.total;

                            items = _.orderBy(items, ['by.id'], ['desc']);

                            resolve({
                                items,
                                total,
                            });
                        })
                        .catch(error => {
                            reject(error.response.data);
                        });
                })
            },

            getOverall() {
                axios.get('api/chart/affiliate/overall')
                    .then(({ data }) => {
                        this.overall = {...data};
                        this.loadingOverall = false;
                    })
            },

            onTotalSalesDateChange() {
                this.getTotalSales();
            },

            getTotalSales() {
                this.loadingTotalSalesChart = true;

                axios.get('api/chart/affiliate/sales', {
                    params: {
                        date: this.totalSalesDate
                    }
                })
                    .then(({ data }) => {
                        this.sales = ({
                            datasets: [{
                                borderColor: "#5e72e4",
                                pointBackgroundColor: "#ffffff",
                                showLine: true,
                                fill: false,
                                data: data.data
                            }]
                        });

                        this.loadingTotalSalesChart = false;
                    })
            },

            onTotalMemberSalesDateChange() {
                this.getTotalMemberSales();
            },

            getTotalMemberSales() {
                this.loadingTotalMemberSalesChart = true;

                axios.get('api/chart/affiliate/member/sales').then(({ data }) => {
                    let datasets = [];

                    let grouped = _(data.data)
                        .groupBy('name')
                        .map((items, name) => {
                            return {
                                name: name,
                                chart: _.map(items, 'chart')
                            };
                        })
                        .value();

                    grouped.forEach(sales => {
                        datasets.push({
                            label: sales.name,
                            borderColor: this.randomColor(),
                            pointBackgroundColor: "#ffffff",
                            showLine: true,
                            fill: false,
                            data: sales.chart
                        })
                    });

                    this.memberSales = ({
                        datasets: datasets
                    });

                    this.loadingTotalMemberSalesChart = false;
                })
            },

            editReferralCode() {
                if (!this.editing) {
                    this.editing = this.overall.referral_code;
                    this.$nextTick(() => this.$refs["code"].$refs.input.focus());
                }
                else {
                    this.updatingCode = true;

                    this.$refs.observer.validate()
                        .then(valid => {
                            if(valid) {
                                this.apiUpdateCode()
                                    .then(updated => {
                                        if(updated) {
                                            this.updatingCode = false;
                                            this.editing = null;
                                        }
                                    })
                                    .catch(error => {
                                        this.$refs.observer.setErrors(error.errors);
                                        this.updatingCode = false;
                                    });
                            }
                            else {
                                this.updatingCode = false;
                            }
                        });
                }
            },

            apiUpdateCode() {
                return new Promise((resolve, reject) => {
                    axios.post('api/affiliate/referral/code', { ref_code: this.overall.referral_code })
                        .then(({ data }) => {
                            resolve(data)
                        })
                        .catch(error => {
                            reject(error.response.data)
                        })
                })
            }
        }
    }
</script>

<style scoped>
    .sales {
        background-color: #17254c;
    }

    .referral-code {
        max-width: 250px;
    }

    .referral-code.v-input--is-disabled >>> input {
        color: black !important;
    }
</style>
